//---------------------------------------------------------
//  RG Basic Tools Collection
//  Copyright © 2007 -2009 Ronald D. Grindle
//---------------------------------------------------------
package com.qanavigation.Basics;

/**
 * 
 * String that carries ab HTML encoded string
 *
 */
public class RsltHTMLString extends Rslt {
	
	private boolean m_isEncoded;
	private String m_theString;
	
	/**
	 * Status "isEmpty" by default.
	 *
	 */
	public RsltHTMLString() {
		
		init();
	}
	
	/**
	 * 
	 * @param p_IsOK
	 */
	public RsltHTMLString( boolean p_IsOK ) {
		
		init();
		
		if( p_IsOK ) {
			
			setOK();
		}		
	}
	
	/**
	 * 
	 * @param p_String
	 * @param p_isEncoded
	 */
	public RsltHTMLString( String p_String, boolean p_isEncoded ) {
			
		m_theString = p_String;
		
		m_isEncoded = p_isEncoded;
		
		setOK();
	}
	
	/**
	 * 
	 * @param p_Str
	 */
	public void appString( String p_Str,  boolean p_isEncoded ) {
		
		if( isOK( true ) ) {
			
			if( m_isEncoded == p_isEncoded ) {
		
				m_theString += p_Str;
			}
			else if( p_isEncoded && !( m_isEncoded ) ) {
				
				m_theString += SFormatter.decodeHTML( p_Str );
			}
			else if( !( p_isEncoded ) && m_isEncoded ) {
				
				m_theString += SFormatter.encodeHTML( p_Str );			
			}
			
			setOK();
		}
	}
	
	/**
	 * Decodes the string to HTML.
	 * @return
	 */
	public boolean decString( ) {
		
		if( m_isEncoded ) {
			
			m_theString = SFormatter.decodeHTML( m_theString );
			
			m_isEncoded = false;
		}

		return m_isEncoded;
	}

	/**
	 * Encodes the string to HTML.
	 * @return
	 */
	public boolean encString( ) {
		
		if( !( m_isEncoded ) ) {
			
			m_theString = SFormatter.encodeHTML( m_theString );
			
			m_isEncoded = true;
		}

		return m_isEncoded;
	}
	
	/**
	 * Returns the string in the required state.
	 * @param p_encoded
	 * @return
	 */
	public String getString( boolean p_encoded  ) {
		
		String res = "";
		
		if( p_encoded == m_isEncoded ) {
			
			res = m_theString;
		}
		else if( p_encoded && !( m_isEncoded ) ) {
			
			res = SFormatter.encodeHTML( m_theString );
		}
		else if( !( p_encoded ) && m_isEncoded ) {
			
			res = SFormatter.decodeHTML( m_theString );			
		}

		return res;
	}
	
	// --------------------------------------------------------------------------
	protected void init() {

		super.init();

		m_theString = "";
		
		m_isEncoded = true;

		setRsltStat( RsltStatVal.isEmpty );
	}
	
	/**
	 * 
	 * @return true if string value is empty
	 */
	public boolean isEmpty() {

		boolean isEmpty = false;
			
		if( m_ResStat == RsltStatVal.isEmpty ) {
			
			isEmpty = true;
		}
		else {
			
			if( m_theString.length() < 1 ){
				
				isEmpty = true;
			}
		}
		
		return isEmpty;
	}

	/**
	 * Sets the string value. A null is converted to "" and the status is set "empty", otherwise "OK".
	 * @param p_String
	 */
	public void	setString( String p_String, boolean p_isEncoded )
	{ 
		
		if( null == p_String ) {
			
			setRsltStat( RsltStatVal.isEmpty );
			
			m_isEncoded = true;
			
			m_theString = "";
		}
		else {

			m_theString = p_String;
			
			m_isEncoded = p_isEncoded;
			
			setOK();
		}
	}
}
