//---------------------------------------------------------
//  RG Basic Tools Collection
//  Copyright © 2004 -2009 Ronald D. Grindle
//
//This file is part of the Rslt services.
//
//Rslt services is free software: you can redistribute it and/or modify
//it under the terms of the GNU General Public License as published by
//the Free Software Foundation, either version 3 of the License, or
//(at your option) any later version.
//
//Rslt services is distributed in the hope that it will be useful,
//but WITHOUT ANY WARRANTY; without even the implied warranty of
//MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
//GNU General Public License for more details.
//
//You should have received a copy of the GNU General Public License
//along with Rslt services.  If not, see <http://www.gnu.org/licenses/>.
//---------------------------------------------------------
package com.qanavigation.XMLBasics;

import org.xml.sax.ErrorHandler;
import org.xml.sax.SAXException;
import org.xml.sax.SAXParseException;

/** Standard SAX ErrorHandler methods.
 * @author RDG
 *
 */
public class XErrorHandler implements ErrorHandler {

	// -------------------------------------------
	public XErrorHandler( ) {

	}

	// -------------------------------------------
	public void warning( SAXParseException sPE)
							throws SAXException {
	
		String message = "Warning: " + getExcInfo( sPE );
		throw new SAXException( message );
	}

	// -------------------------------------------
	public void error( SAXParseException sPE ) 
							throws SAXException {

		String message = "Error: " + getExcInfo( sPE );
		throw new SAXException( message );
	}

	// -------------------------------------------
	public void fatalError( SAXParseException sPE ) 
							throws SAXException {

		String message = "Fatal Error: " + getExcInfo(sPE);
		throw new SAXException( message );
	}

	// -------------------------------------------
	// return exception details
	private String getExcInfo( SAXParseException sPE ) {

	  String sysID = sPE.getSystemId();

	  if ( sysID == null ) {
	
		sysID = "null";
	  }
	
	  String info = "URI=" + sysID + " Line=" + sPE.getLineNumber() 
										+ ": " + sPE.getMessage();
	
	  return info;
	
	}

}

